<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdditionalCostDefinition ArrayType
 * @subpackage Arrays
 */
class ArrayOfAdditionalCostDefinition extends AbstractStructArrayBase
{
    /**
     * The AdditionalCostDefinition
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdditionalCostDefinition[]
     */
    public $AdditionalCostDefinition;
    /**
     * Constructor method for ArrayOfAdditionalCostDefinition
     * @uses ArrayOfAdditionalCostDefinition::setAdditionalCostDefinition()
     * @param \StructType\AdditionalCostDefinition[] $additionalCostDefinition
     */
    public function __construct(array $additionalCostDefinition = array())
    {
        $this
            ->setAdditionalCostDefinition($additionalCostDefinition);
    }
    /**
     * Get AdditionalCostDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdditionalCostDefinition[]|null
     */
    public function getAdditionalCostDefinition()
    {
        return isset($this->AdditionalCostDefinition) ? $this->AdditionalCostDefinition : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdditionalCostDefinition method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdditionalCostDefinition method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdditionalCostDefinitionForArrayConstraintsFromSetAdditionalCostDefinition(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdditionalCostDefinitionAdditionalCostDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdditionalCostDefinitionAdditionalCostDefinitionItem instanceof \StructType\AdditionalCostDefinition) {
                $invalidValues[] = is_object($arrayOfAdditionalCostDefinitionAdditionalCostDefinitionItem) ? get_class($arrayOfAdditionalCostDefinitionAdditionalCostDefinitionItem) : sprintf('%s(%s)', gettype($arrayOfAdditionalCostDefinitionAdditionalCostDefinitionItem), var_export($arrayOfAdditionalCostDefinitionAdditionalCostDefinitionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdditionalCostDefinition property can only contain items of type \StructType\AdditionalCostDefinition, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdditionalCostDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdditionalCostDefinition[] $additionalCostDefinition
     * @return \ArrayType\ArrayOfAdditionalCostDefinition
     */
    public function setAdditionalCostDefinition(array $additionalCostDefinition = array())
    {
        // validation for constraint: array
        if ('' !== ($additionalCostDefinitionArrayErrorMessage = self::validateAdditionalCostDefinitionForArrayConstraintsFromSetAdditionalCostDefinition($additionalCostDefinition))) {
            throw new \InvalidArgumentException($additionalCostDefinitionArrayErrorMessage, __LINE__);
        }
        if (is_null($additionalCostDefinition) || (is_array($additionalCostDefinition) && empty($additionalCostDefinition))) {
            unset($this->AdditionalCostDefinition);
        } else {
            $this->AdditionalCostDefinition = $additionalCostDefinition;
        }
        return $this;
    }
    /**
     * Add item to AdditionalCostDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\AdditionalCostDefinition $item
     * @return \ArrayType\ArrayOfAdditionalCostDefinition
     */
    public function addToAdditionalCostDefinition(\StructType\AdditionalCostDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdditionalCostDefinition) {
            throw new \InvalidArgumentException(sprintf('The AdditionalCostDefinition property can only contain items of type \StructType\AdditionalCostDefinition, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdditionalCostDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdditionalCostDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdditionalCostDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdditionalCostDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdditionalCostDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdditionalCostDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdditionalCostDefinition
     */
    public function getAttributeName()
    {
        return 'AdditionalCostDefinition';
    }
}
