<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBranchPrice ArrayType
 * @subpackage Arrays
 */
class ArrayOfBranchPrice extends AbstractStructArrayBase
{
    /**
     * The BranchPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BranchPrice[]
     */
    public $BranchPrice;
    /**
     * Constructor method for ArrayOfBranchPrice
     * @uses ArrayOfBranchPrice::setBranchPrice()
     * @param \StructType\BranchPrice[] $branchPrice
     */
    public function __construct(array $branchPrice = array())
    {
        $this
            ->setBranchPrice($branchPrice);
    }
    /**
     * Get BranchPrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BranchPrice[]|null
     */
    public function getBranchPrice()
    {
        return isset($this->BranchPrice) ? $this->BranchPrice : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBranchPrice method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBranchPrice method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBranchPriceForArrayConstraintsFromSetBranchPrice(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBranchPriceBranchPriceItem) {
            // validation for constraint: itemType
            if (!$arrayOfBranchPriceBranchPriceItem instanceof \StructType\BranchPrice) {
                $invalidValues[] = is_object($arrayOfBranchPriceBranchPriceItem) ? get_class($arrayOfBranchPriceBranchPriceItem) : sprintf('%s(%s)', gettype($arrayOfBranchPriceBranchPriceItem), var_export($arrayOfBranchPriceBranchPriceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BranchPrice property can only contain items of type \StructType\BranchPrice, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BranchPrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BranchPrice[] $branchPrice
     * @return \ArrayType\ArrayOfBranchPrice
     */
    public function setBranchPrice(array $branchPrice = array())
    {
        // validation for constraint: array
        if ('' !== ($branchPriceArrayErrorMessage = self::validateBranchPriceForArrayConstraintsFromSetBranchPrice($branchPrice))) {
            throw new \InvalidArgumentException($branchPriceArrayErrorMessage, __LINE__);
        }
        if (is_null($branchPrice) || (is_array($branchPrice) && empty($branchPrice))) {
            unset($this->BranchPrice);
        } else {
            $this->BranchPrice = $branchPrice;
        }
        return $this;
    }
    /**
     * Add item to BranchPrice value
     * @throws \InvalidArgumentException
     * @param \StructType\BranchPrice $item
     * @return \ArrayType\ArrayOfBranchPrice
     */
    public function addToBranchPrice(\StructType\BranchPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BranchPrice) {
            throw new \InvalidArgumentException(sprintf('The BranchPrice property can only contain items of type \StructType\BranchPrice, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BranchPrice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BranchPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BranchPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BranchPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BranchPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BranchPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BranchPrice
     */
    public function getAttributeName()
    {
        return 'BranchPrice';
    }
}
