<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfColorEanPrices ArrayType
 * @subpackage Arrays
 */
class ArrayOfColorEanPrices extends AbstractStructArrayBase
{
    /**
     * The ColorEanPrices
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ColorEanPrices[]
     */
    public $ColorEanPrices;
    /**
     * Constructor method for ArrayOfColorEanPrices
     * @uses ArrayOfColorEanPrices::setColorEanPrices()
     * @param \StructType\ColorEanPrices[] $colorEanPrices
     */
    public function __construct(array $colorEanPrices = array())
    {
        $this
            ->setColorEanPrices($colorEanPrices);
    }
    /**
     * Get ColorEanPrices value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ColorEanPrices[]|null
     */
    public function getColorEanPrices()
    {
        return isset($this->ColorEanPrices) ? $this->ColorEanPrices : null;
    }
    /**
     * This method is responsible for validating the values passed to the setColorEanPrices method
     * This method is willingly generated in order to preserve the one-line inline validation within the setColorEanPrices method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateColorEanPricesForArrayConstraintsFromSetColorEanPrices(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfColorEanPricesColorEanPricesItem) {
            // validation for constraint: itemType
            if (!$arrayOfColorEanPricesColorEanPricesItem instanceof \StructType\ColorEanPrices) {
                $invalidValues[] = is_object($arrayOfColorEanPricesColorEanPricesItem) ? get_class($arrayOfColorEanPricesColorEanPricesItem) : sprintf('%s(%s)', gettype($arrayOfColorEanPricesColorEanPricesItem), var_export($arrayOfColorEanPricesColorEanPricesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ColorEanPrices property can only contain items of type \StructType\ColorEanPrices, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ColorEanPrices value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ColorEanPrices[] $colorEanPrices
     * @return \ArrayType\ArrayOfColorEanPrices
     */
    public function setColorEanPrices(array $colorEanPrices = array())
    {
        // validation for constraint: array
        if ('' !== ($colorEanPricesArrayErrorMessage = self::validateColorEanPricesForArrayConstraintsFromSetColorEanPrices($colorEanPrices))) {
            throw new \InvalidArgumentException($colorEanPricesArrayErrorMessage, __LINE__);
        }
        if (is_null($colorEanPrices) || (is_array($colorEanPrices) && empty($colorEanPrices))) {
            unset($this->ColorEanPrices);
        } else {
            $this->ColorEanPrices = $colorEanPrices;
        }
        return $this;
    }
    /**
     * Add item to ColorEanPrices value
     * @throws \InvalidArgumentException
     * @param \StructType\ColorEanPrices $item
     * @return \ArrayType\ArrayOfColorEanPrices
     */
    public function addToColorEanPrices(\StructType\ColorEanPrices $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ColorEanPrices) {
            throw new \InvalidArgumentException(sprintf('The ColorEanPrices property can only contain items of type \StructType\ColorEanPrices, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ColorEanPrices[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ColorEanPrices|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ColorEanPrices|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ColorEanPrices|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ColorEanPrices|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ColorEanPrices|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ColorEanPrices
     */
    public function getAttributeName()
    {
        return 'ColorEanPrices';
    }
}
