<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCommChannelType ArrayType
 * @subpackage Arrays
 */
class ArrayOfCommChannelType extends AbstractStructArrayBase
{
    /**
     * The CommChannelType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CommChannelType[]
     */
    public $CommChannelType;
    /**
     * Constructor method for ArrayOfCommChannelType
     * @uses ArrayOfCommChannelType::setCommChannelType()
     * @param \StructType\CommChannelType[] $commChannelType
     */
    public function __construct(array $commChannelType = array())
    {
        $this
            ->setCommChannelType($commChannelType);
    }
    /**
     * Get CommChannelType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CommChannelType[]|null
     */
    public function getCommChannelType()
    {
        return isset($this->CommChannelType) ? $this->CommChannelType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCommChannelType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCommChannelType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCommChannelTypeForArrayConstraintsFromSetCommChannelType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCommChannelTypeCommChannelTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfCommChannelTypeCommChannelTypeItem instanceof \StructType\CommChannelType) {
                $invalidValues[] = is_object($arrayOfCommChannelTypeCommChannelTypeItem) ? get_class($arrayOfCommChannelTypeCommChannelTypeItem) : sprintf('%s(%s)', gettype($arrayOfCommChannelTypeCommChannelTypeItem), var_export($arrayOfCommChannelTypeCommChannelTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CommChannelType property can only contain items of type \StructType\CommChannelType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CommChannelType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CommChannelType[] $commChannelType
     * @return \ArrayType\ArrayOfCommChannelType
     */
    public function setCommChannelType(array $commChannelType = array())
    {
        // validation for constraint: array
        if ('' !== ($commChannelTypeArrayErrorMessage = self::validateCommChannelTypeForArrayConstraintsFromSetCommChannelType($commChannelType))) {
            throw new \InvalidArgumentException($commChannelTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($commChannelType) || (is_array($commChannelType) && empty($commChannelType))) {
            unset($this->CommChannelType);
        } else {
            $this->CommChannelType = $commChannelType;
        }
        return $this;
    }
    /**
     * Add item to CommChannelType value
     * @throws \InvalidArgumentException
     * @param \StructType\CommChannelType $item
     * @return \ArrayType\ArrayOfCommChannelType
     */
    public function addToCommChannelType(\StructType\CommChannelType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CommChannelType) {
            throw new \InvalidArgumentException(sprintf('The CommChannelType property can only contain items of type \StructType\CommChannelType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CommChannelType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CommChannelType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CommChannelType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CommChannelType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CommChannelType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CommChannelType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CommChannelType
     */
    public function getAttributeName()
    {
        return 'CommChannelType';
    }
}
