<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerPurchaseHistory ArrayType
 * @subpackage Arrays
 */
class ArrayOfCustomerPurchaseHistory extends AbstractStructArrayBase
{
    /**
     * The CustomerPurchaseHistory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CustomerPurchaseHistory[]
     */
    public $CustomerPurchaseHistory;
    /**
     * Constructor method for ArrayOfCustomerPurchaseHistory
     * @uses ArrayOfCustomerPurchaseHistory::setCustomerPurchaseHistory()
     * @param \StructType\CustomerPurchaseHistory[] $customerPurchaseHistory
     */
    public function __construct(array $customerPurchaseHistory = array())
    {
        $this
            ->setCustomerPurchaseHistory($customerPurchaseHistory);
    }
    /**
     * Get CustomerPurchaseHistory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CustomerPurchaseHistory[]|null
     */
    public function getCustomerPurchaseHistory()
    {
        return isset($this->CustomerPurchaseHistory) ? $this->CustomerPurchaseHistory : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerPurchaseHistory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerPurchaseHistory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerPurchaseHistoryForArrayConstraintsFromSetCustomerPurchaseHistory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomerPurchaseHistoryCustomerPurchaseHistoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomerPurchaseHistoryCustomerPurchaseHistoryItem instanceof \StructType\CustomerPurchaseHistory) {
                $invalidValues[] = is_object($arrayOfCustomerPurchaseHistoryCustomerPurchaseHistoryItem) ? get_class($arrayOfCustomerPurchaseHistoryCustomerPurchaseHistoryItem) : sprintf('%s(%s)', gettype($arrayOfCustomerPurchaseHistoryCustomerPurchaseHistoryItem), var_export($arrayOfCustomerPurchaseHistoryCustomerPurchaseHistoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomerPurchaseHistory property can only contain items of type \StructType\CustomerPurchaseHistory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerPurchaseHistory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerPurchaseHistory[] $customerPurchaseHistory
     * @return \ArrayType\ArrayOfCustomerPurchaseHistory
     */
    public function setCustomerPurchaseHistory(array $customerPurchaseHistory = array())
    {
        // validation for constraint: array
        if ('' !== ($customerPurchaseHistoryArrayErrorMessage = self::validateCustomerPurchaseHistoryForArrayConstraintsFromSetCustomerPurchaseHistory($customerPurchaseHistory))) {
            throw new \InvalidArgumentException($customerPurchaseHistoryArrayErrorMessage, __LINE__);
        }
        if (is_null($customerPurchaseHistory) || (is_array($customerPurchaseHistory) && empty($customerPurchaseHistory))) {
            unset($this->CustomerPurchaseHistory);
        } else {
            $this->CustomerPurchaseHistory = $customerPurchaseHistory;
        }
        return $this;
    }
    /**
     * Add item to CustomerPurchaseHistory value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerPurchaseHistory $item
     * @return \ArrayType\ArrayOfCustomerPurchaseHistory
     */
    public function addToCustomerPurchaseHistory(\StructType\CustomerPurchaseHistory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerPurchaseHistory) {
            throw new \InvalidArgumentException(sprintf('The CustomerPurchaseHistory property can only contain items of type \StructType\CustomerPurchaseHistory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomerPurchaseHistory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CustomerPurchaseHistory|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CustomerPurchaseHistory|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CustomerPurchaseHistory|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CustomerPurchaseHistory|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CustomerPurchaseHistory|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerPurchaseHistory
     */
    public function getAttributeName()
    {
        return 'CustomerPurchaseHistory';
    }
}
