<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeliveryNotePosition ArrayType
 * @subpackage Arrays
 */
class ArrayOfDeliveryNotePosition extends AbstractStructArrayBase
{
    /**
     * The DeliveryNotePosition
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DeliveryNotePosition[]
     */
    public $DeliveryNotePosition;
    /**
     * Constructor method for ArrayOfDeliveryNotePosition
     * @uses ArrayOfDeliveryNotePosition::setDeliveryNotePosition()
     * @param \StructType\DeliveryNotePosition[] $deliveryNotePosition
     */
    public function __construct(array $deliveryNotePosition = array())
    {
        $this
            ->setDeliveryNotePosition($deliveryNotePosition);
    }
    /**
     * Get DeliveryNotePosition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DeliveryNotePosition[]|null
     */
    public function getDeliveryNotePosition()
    {
        return isset($this->DeliveryNotePosition) ? $this->DeliveryNotePosition : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeliveryNotePosition method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeliveryNotePosition method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeliveryNotePositionForArrayConstraintsFromSetDeliveryNotePosition(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeliveryNotePositionDeliveryNotePositionItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeliveryNotePositionDeliveryNotePositionItem instanceof \StructType\DeliveryNotePosition) {
                $invalidValues[] = is_object($arrayOfDeliveryNotePositionDeliveryNotePositionItem) ? get_class($arrayOfDeliveryNotePositionDeliveryNotePositionItem) : sprintf('%s(%s)', gettype($arrayOfDeliveryNotePositionDeliveryNotePositionItem), var_export($arrayOfDeliveryNotePositionDeliveryNotePositionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeliveryNotePosition property can only contain items of type \StructType\DeliveryNotePosition, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeliveryNotePosition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryNotePosition[] $deliveryNotePosition
     * @return \ArrayType\ArrayOfDeliveryNotePosition
     */
    public function setDeliveryNotePosition(array $deliveryNotePosition = array())
    {
        // validation for constraint: array
        if ('' !== ($deliveryNotePositionArrayErrorMessage = self::validateDeliveryNotePositionForArrayConstraintsFromSetDeliveryNotePosition($deliveryNotePosition))) {
            throw new \InvalidArgumentException($deliveryNotePositionArrayErrorMessage, __LINE__);
        }
        if (is_null($deliveryNotePosition) || (is_array($deliveryNotePosition) && empty($deliveryNotePosition))) {
            unset($this->DeliveryNotePosition);
        } else {
            $this->DeliveryNotePosition = $deliveryNotePosition;
        }
        return $this;
    }
    /**
     * Add item to DeliveryNotePosition value
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryNotePosition $item
     * @return \ArrayType\ArrayOfDeliveryNotePosition
     */
    public function addToDeliveryNotePosition(\StructType\DeliveryNotePosition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeliveryNotePosition) {
            throw new \InvalidArgumentException(sprintf('The DeliveryNotePosition property can only contain items of type \StructType\DeliveryNotePosition, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeliveryNotePosition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeliveryNotePosition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeliveryNotePosition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeliveryNotePosition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeliveryNotePosition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeliveryNotePosition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeliveryNotePosition
     */
    public function getAttributeName()
    {
        return 'DeliveryNotePosition';
    }
}
