<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEanBranchPrices ArrayType
 * @subpackage Arrays
 */
class ArrayOfEanBranchPrices extends AbstractStructArrayBase
{
    /**
     * The EanBranchPrices
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EanBranchPrices[]
     */
    public $EanBranchPrices;
    /**
     * Constructor method for ArrayOfEanBranchPrices
     * @uses ArrayOfEanBranchPrices::setEanBranchPrices()
     * @param \StructType\EanBranchPrices[] $eanBranchPrices
     */
    public function __construct(array $eanBranchPrices = array())
    {
        $this
            ->setEanBranchPrices($eanBranchPrices);
    }
    /**
     * Get EanBranchPrices value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EanBranchPrices[]|null
     */
    public function getEanBranchPrices()
    {
        return isset($this->EanBranchPrices) ? $this->EanBranchPrices : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEanBranchPrices method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEanBranchPrices method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEanBranchPricesForArrayConstraintsFromSetEanBranchPrices(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEanBranchPricesEanBranchPricesItem) {
            // validation for constraint: itemType
            if (!$arrayOfEanBranchPricesEanBranchPricesItem instanceof \StructType\EanBranchPrices) {
                $invalidValues[] = is_object($arrayOfEanBranchPricesEanBranchPricesItem) ? get_class($arrayOfEanBranchPricesEanBranchPricesItem) : sprintf('%s(%s)', gettype($arrayOfEanBranchPricesEanBranchPricesItem), var_export($arrayOfEanBranchPricesEanBranchPricesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EanBranchPrices property can only contain items of type \StructType\EanBranchPrices, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EanBranchPrices value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EanBranchPrices[] $eanBranchPrices
     * @return \ArrayType\ArrayOfEanBranchPrices
     */
    public function setEanBranchPrices(array $eanBranchPrices = array())
    {
        // validation for constraint: array
        if ('' !== ($eanBranchPricesArrayErrorMessage = self::validateEanBranchPricesForArrayConstraintsFromSetEanBranchPrices($eanBranchPrices))) {
            throw new \InvalidArgumentException($eanBranchPricesArrayErrorMessage, __LINE__);
        }
        if (is_null($eanBranchPrices) || (is_array($eanBranchPrices) && empty($eanBranchPrices))) {
            unset($this->EanBranchPrices);
        } else {
            $this->EanBranchPrices = $eanBranchPrices;
        }
        return $this;
    }
    /**
     * Add item to EanBranchPrices value
     * @throws \InvalidArgumentException
     * @param \StructType\EanBranchPrices $item
     * @return \ArrayType\ArrayOfEanBranchPrices
     */
    public function addToEanBranchPrices(\StructType\EanBranchPrices $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EanBranchPrices) {
            throw new \InvalidArgumentException(sprintf('The EanBranchPrices property can only contain items of type \StructType\EanBranchPrices, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EanBranchPrices[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EanBranchPrices|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EanBranchPrices|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EanBranchPrices|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EanBranchPrices|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EanBranchPrices|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EanBranchPrices
     */
    public function getAttributeName()
    {
        return 'EanBranchPrices';
    }
}
