<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGoodsInAdviceDetail ArrayType
 * @subpackage Arrays
 */
class ArrayOfGoodsInAdviceDetail extends AbstractStructArrayBase
{
    /**
     * The GoodsInAdviceDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GoodsInAdviceDetail[]
     */
    public $GoodsInAdviceDetail;
    /**
     * Constructor method for ArrayOfGoodsInAdviceDetail
     * @uses ArrayOfGoodsInAdviceDetail::setGoodsInAdviceDetail()
     * @param \StructType\GoodsInAdviceDetail[] $goodsInAdviceDetail
     */
    public function __construct(array $goodsInAdviceDetail = array())
    {
        $this
            ->setGoodsInAdviceDetail($goodsInAdviceDetail);
    }
    /**
     * Get GoodsInAdviceDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GoodsInAdviceDetail[]|null
     */
    public function getGoodsInAdviceDetail()
    {
        return isset($this->GoodsInAdviceDetail) ? $this->GoodsInAdviceDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGoodsInAdviceDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGoodsInAdviceDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGoodsInAdviceDetailForArrayConstraintsFromSetGoodsInAdviceDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGoodsInAdviceDetailGoodsInAdviceDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfGoodsInAdviceDetailGoodsInAdviceDetailItem instanceof \StructType\GoodsInAdviceDetail) {
                $invalidValues[] = is_object($arrayOfGoodsInAdviceDetailGoodsInAdviceDetailItem) ? get_class($arrayOfGoodsInAdviceDetailGoodsInAdviceDetailItem) : sprintf('%s(%s)', gettype($arrayOfGoodsInAdviceDetailGoodsInAdviceDetailItem), var_export($arrayOfGoodsInAdviceDetailGoodsInAdviceDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GoodsInAdviceDetail property can only contain items of type \StructType\GoodsInAdviceDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GoodsInAdviceDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GoodsInAdviceDetail[] $goodsInAdviceDetail
     * @return \ArrayType\ArrayOfGoodsInAdviceDetail
     */
    public function setGoodsInAdviceDetail(array $goodsInAdviceDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($goodsInAdviceDetailArrayErrorMessage = self::validateGoodsInAdviceDetailForArrayConstraintsFromSetGoodsInAdviceDetail($goodsInAdviceDetail))) {
            throw new \InvalidArgumentException($goodsInAdviceDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($goodsInAdviceDetail) || (is_array($goodsInAdviceDetail) && empty($goodsInAdviceDetail))) {
            unset($this->GoodsInAdviceDetail);
        } else {
            $this->GoodsInAdviceDetail = $goodsInAdviceDetail;
        }
        return $this;
    }
    /**
     * Add item to GoodsInAdviceDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\GoodsInAdviceDetail $item
     * @return \ArrayType\ArrayOfGoodsInAdviceDetail
     */
    public function addToGoodsInAdviceDetail(\StructType\GoodsInAdviceDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GoodsInAdviceDetail) {
            throw new \InvalidArgumentException(sprintf('The GoodsInAdviceDetail property can only contain items of type \StructType\GoodsInAdviceDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GoodsInAdviceDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GoodsInAdviceDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GoodsInAdviceDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GoodsInAdviceDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GoodsInAdviceDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GoodsInAdviceDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GoodsInAdviceDetail
     */
    public function getAttributeName()
    {
        return 'GoodsInAdviceDetail';
    }
}
