<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGoodsInAdviceDetailRequest ArrayType
 * @subpackage Arrays
 */
class ArrayOfGoodsInAdviceDetailRequest extends AbstractStructArrayBase
{
    /**
     * The GoodsInAdviceDetailRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GoodsInAdviceDetailRequest[]
     */
    public $GoodsInAdviceDetailRequest;
    /**
     * Constructor method for ArrayOfGoodsInAdviceDetailRequest
     * @uses ArrayOfGoodsInAdviceDetailRequest::setGoodsInAdviceDetailRequest()
     * @param \StructType\GoodsInAdviceDetailRequest[] $goodsInAdviceDetailRequest
     */
    public function __construct(array $goodsInAdviceDetailRequest = array())
    {
        $this
            ->setGoodsInAdviceDetailRequest($goodsInAdviceDetailRequest);
    }
    /**
     * Get GoodsInAdviceDetailRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GoodsInAdviceDetailRequest[]|null
     */
    public function getGoodsInAdviceDetailRequest()
    {
        return isset($this->GoodsInAdviceDetailRequest) ? $this->GoodsInAdviceDetailRequest : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGoodsInAdviceDetailRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGoodsInAdviceDetailRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGoodsInAdviceDetailRequestForArrayConstraintsFromSetGoodsInAdviceDetailRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGoodsInAdviceDetailRequestGoodsInAdviceDetailRequestItem) {
            // validation for constraint: itemType
            if (!$arrayOfGoodsInAdviceDetailRequestGoodsInAdviceDetailRequestItem instanceof \StructType\GoodsInAdviceDetailRequest) {
                $invalidValues[] = is_object($arrayOfGoodsInAdviceDetailRequestGoodsInAdviceDetailRequestItem) ? get_class($arrayOfGoodsInAdviceDetailRequestGoodsInAdviceDetailRequestItem) : sprintf('%s(%s)', gettype($arrayOfGoodsInAdviceDetailRequestGoodsInAdviceDetailRequestItem), var_export($arrayOfGoodsInAdviceDetailRequestGoodsInAdviceDetailRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GoodsInAdviceDetailRequest property can only contain items of type \StructType\GoodsInAdviceDetailRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GoodsInAdviceDetailRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GoodsInAdviceDetailRequest[] $goodsInAdviceDetailRequest
     * @return \ArrayType\ArrayOfGoodsInAdviceDetailRequest
     */
    public function setGoodsInAdviceDetailRequest(array $goodsInAdviceDetailRequest = array())
    {
        // validation for constraint: array
        if ('' !== ($goodsInAdviceDetailRequestArrayErrorMessage = self::validateGoodsInAdviceDetailRequestForArrayConstraintsFromSetGoodsInAdviceDetailRequest($goodsInAdviceDetailRequest))) {
            throw new \InvalidArgumentException($goodsInAdviceDetailRequestArrayErrorMessage, __LINE__);
        }
        if (is_null($goodsInAdviceDetailRequest) || (is_array($goodsInAdviceDetailRequest) && empty($goodsInAdviceDetailRequest))) {
            unset($this->GoodsInAdviceDetailRequest);
        } else {
            $this->GoodsInAdviceDetailRequest = $goodsInAdviceDetailRequest;
        }
        return $this;
    }
    /**
     * Add item to GoodsInAdviceDetailRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\GoodsInAdviceDetailRequest $item
     * @return \ArrayType\ArrayOfGoodsInAdviceDetailRequest
     */
    public function addToGoodsInAdviceDetailRequest(\StructType\GoodsInAdviceDetailRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GoodsInAdviceDetailRequest) {
            throw new \InvalidArgumentException(sprintf('The GoodsInAdviceDetailRequest property can only contain items of type \StructType\GoodsInAdviceDetailRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GoodsInAdviceDetailRequest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GoodsInAdviceDetailRequest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GoodsInAdviceDetailRequest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GoodsInAdviceDetailRequest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GoodsInAdviceDetailRequest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GoodsInAdviceDetailRequest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GoodsInAdviceDetailRequest
     */
    public function getAttributeName()
    {
        return 'GoodsInAdviceDetailRequest';
    }
}
