<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInterBranchTransferHead ArrayType
 * @subpackage Arrays
 */
class ArrayOfInterBranchTransferHead extends AbstractStructArrayBase
{
    /**
     * The InterBranchTransferHead
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InterBranchTransferHead[]
     */
    public $InterBranchTransferHead;
    /**
     * Constructor method for ArrayOfInterBranchTransferHead
     * @uses ArrayOfInterBranchTransferHead::setInterBranchTransferHead()
     * @param \StructType\InterBranchTransferHead[] $interBranchTransferHead
     */
    public function __construct(array $interBranchTransferHead = array())
    {
        $this
            ->setInterBranchTransferHead($interBranchTransferHead);
    }
    /**
     * Get InterBranchTransferHead value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InterBranchTransferHead[]|null
     */
    public function getInterBranchTransferHead()
    {
        return isset($this->InterBranchTransferHead) ? $this->InterBranchTransferHead : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInterBranchTransferHead method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInterBranchTransferHead method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInterBranchTransferHeadForArrayConstraintsFromSetInterBranchTransferHead(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInterBranchTransferHeadInterBranchTransferHeadItem) {
            // validation for constraint: itemType
            if (!$arrayOfInterBranchTransferHeadInterBranchTransferHeadItem instanceof \StructType\InterBranchTransferHead) {
                $invalidValues[] = is_object($arrayOfInterBranchTransferHeadInterBranchTransferHeadItem) ? get_class($arrayOfInterBranchTransferHeadInterBranchTransferHeadItem) : sprintf('%s(%s)', gettype($arrayOfInterBranchTransferHeadInterBranchTransferHeadItem), var_export($arrayOfInterBranchTransferHeadInterBranchTransferHeadItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InterBranchTransferHead property can only contain items of type \StructType\InterBranchTransferHead, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InterBranchTransferHead value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InterBranchTransferHead[] $interBranchTransferHead
     * @return \ArrayType\ArrayOfInterBranchTransferHead
     */
    public function setInterBranchTransferHead(array $interBranchTransferHead = array())
    {
        // validation for constraint: array
        if ('' !== ($interBranchTransferHeadArrayErrorMessage = self::validateInterBranchTransferHeadForArrayConstraintsFromSetInterBranchTransferHead($interBranchTransferHead))) {
            throw new \InvalidArgumentException($interBranchTransferHeadArrayErrorMessage, __LINE__);
        }
        if (is_null($interBranchTransferHead) || (is_array($interBranchTransferHead) && empty($interBranchTransferHead))) {
            unset($this->InterBranchTransferHead);
        } else {
            $this->InterBranchTransferHead = $interBranchTransferHead;
        }
        return $this;
    }
    /**
     * Add item to InterBranchTransferHead value
     * @throws \InvalidArgumentException
     * @param \StructType\InterBranchTransferHead $item
     * @return \ArrayType\ArrayOfInterBranchTransferHead
     */
    public function addToInterBranchTransferHead(\StructType\InterBranchTransferHead $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterBranchTransferHead) {
            throw new \InvalidArgumentException(sprintf('The InterBranchTransferHead property can only contain items of type \StructType\InterBranchTransferHead, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InterBranchTransferHead[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InterBranchTransferHead|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InterBranchTransferHead|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InterBranchTransferHead|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InterBranchTransferHead|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InterBranchTransferHead|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InterBranchTransferHead
     */
    public function getAttributeName()
    {
        return 'InterBranchTransferHead';
    }
}
