<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReturnReason ArrayType
 * @subpackage Arrays
 */
class ArrayOfReturnReason extends AbstractStructArrayBase
{
    /**
     * The ReturnReason
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ReturnReason[]
     */
    public $ReturnReason;
    /**
     * Constructor method for ArrayOfReturnReason
     * @uses ArrayOfReturnReason::setReturnReason()
     * @param \StructType\ReturnReason[] $returnReason
     */
    public function __construct(array $returnReason = array())
    {
        $this
            ->setReturnReason($returnReason);
    }
    /**
     * Get ReturnReason value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ReturnReason[]|null
     */
    public function getReturnReason()
    {
        return isset($this->ReturnReason) ? $this->ReturnReason : null;
    }
    /**
     * This method is responsible for validating the values passed to the setReturnReason method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReturnReason method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReturnReasonForArrayConstraintsFromSetReturnReason(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfReturnReasonReturnReasonItem) {
            // validation for constraint: itemType
            if (!$arrayOfReturnReasonReturnReasonItem instanceof \StructType\ReturnReason) {
                $invalidValues[] = is_object($arrayOfReturnReasonReturnReasonItem) ? get_class($arrayOfReturnReasonReturnReasonItem) : sprintf('%s(%s)', gettype($arrayOfReturnReasonReturnReasonItem), var_export($arrayOfReturnReasonReturnReasonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReturnReason property can only contain items of type \StructType\ReturnReason, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReturnReason value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ReturnReason[] $returnReason
     * @return \ArrayType\ArrayOfReturnReason
     */
    public function setReturnReason(array $returnReason = array())
    {
        // validation for constraint: array
        if ('' !== ($returnReasonArrayErrorMessage = self::validateReturnReasonForArrayConstraintsFromSetReturnReason($returnReason))) {
            throw new \InvalidArgumentException($returnReasonArrayErrorMessage, __LINE__);
        }
        if (is_null($returnReason) || (is_array($returnReason) && empty($returnReason))) {
            unset($this->ReturnReason);
        } else {
            $this->ReturnReason = $returnReason;
        }
        return $this;
    }
    /**
     * Add item to ReturnReason value
     * @throws \InvalidArgumentException
     * @param \StructType\ReturnReason $item
     * @return \ArrayType\ArrayOfReturnReason
     */
    public function addToReturnReason(\StructType\ReturnReason $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReturnReason) {
            throw new \InvalidArgumentException(sprintf('The ReturnReason property can only contain items of type \StructType\ReturnReason, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReturnReason[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ReturnReason|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ReturnReason|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ReturnReason|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ReturnReason|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ReturnReason|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReturnReason
     */
    public function getAttributeName()
    {
        return 'ReturnReason';
    }
}
