<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSalesReceiptPosition ArrayType
 * @subpackage Arrays
 */
class ArrayOfSalesReceiptPosition extends AbstractStructArrayBase
{
    /**
     * The SalesReceiptPosition
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SalesReceiptPosition[]
     */
    public $SalesReceiptPosition;
    /**
     * Constructor method for ArrayOfSalesReceiptPosition
     * @uses ArrayOfSalesReceiptPosition::setSalesReceiptPosition()
     * @param \StructType\SalesReceiptPosition[] $salesReceiptPosition
     */
    public function __construct(array $salesReceiptPosition = array())
    {
        $this
            ->setSalesReceiptPosition($salesReceiptPosition);
    }
    /**
     * Get SalesReceiptPosition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SalesReceiptPosition[]|null
     */
    public function getSalesReceiptPosition()
    {
        return isset($this->SalesReceiptPosition) ? $this->SalesReceiptPosition : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSalesReceiptPosition method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSalesReceiptPosition method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSalesReceiptPositionForArrayConstraintsFromSetSalesReceiptPosition(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSalesReceiptPositionSalesReceiptPositionItem) {
            // validation for constraint: itemType
            if (!$arrayOfSalesReceiptPositionSalesReceiptPositionItem instanceof \StructType\SalesReceiptPosition) {
                $invalidValues[] = is_object($arrayOfSalesReceiptPositionSalesReceiptPositionItem) ? get_class($arrayOfSalesReceiptPositionSalesReceiptPositionItem) : sprintf('%s(%s)', gettype($arrayOfSalesReceiptPositionSalesReceiptPositionItem), var_export($arrayOfSalesReceiptPositionSalesReceiptPositionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SalesReceiptPosition property can only contain items of type \StructType\SalesReceiptPosition, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SalesReceiptPosition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SalesReceiptPosition[] $salesReceiptPosition
     * @return \ArrayType\ArrayOfSalesReceiptPosition
     */
    public function setSalesReceiptPosition(array $salesReceiptPosition = array())
    {
        // validation for constraint: array
        if ('' !== ($salesReceiptPositionArrayErrorMessage = self::validateSalesReceiptPositionForArrayConstraintsFromSetSalesReceiptPosition($salesReceiptPosition))) {
            throw new \InvalidArgumentException($salesReceiptPositionArrayErrorMessage, __LINE__);
        }
        if (is_null($salesReceiptPosition) || (is_array($salesReceiptPosition) && empty($salesReceiptPosition))) {
            unset($this->SalesReceiptPosition);
        } else {
            $this->SalesReceiptPosition = $salesReceiptPosition;
        }
        return $this;
    }
    /**
     * Add item to SalesReceiptPosition value
     * @throws \InvalidArgumentException
     * @param \StructType\SalesReceiptPosition $item
     * @return \ArrayType\ArrayOfSalesReceiptPosition
     */
    public function addToSalesReceiptPosition(\StructType\SalesReceiptPosition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SalesReceiptPosition) {
            throw new \InvalidArgumentException(sprintf('The SalesReceiptPosition property can only contain items of type \StructType\SalesReceiptPosition, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SalesReceiptPosition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SalesReceiptPosition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SalesReceiptPosition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SalesReceiptPosition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SalesReceiptPosition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SalesReceiptPosition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SalesReceiptPosition
     */
    public function getAttributeName()
    {
        return 'SalesReceiptPosition';
    }
}
