<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSendCustomerCharacteristic ArrayType
 * @subpackage Arrays
 */
class ArrayOfSendCustomerCharacteristic extends AbstractStructArrayBase
{
    /**
     * The SendCustomerCharacteristic
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SendCustomerCharacteristic[]
     */
    public $SendCustomerCharacteristic;
    /**
     * Constructor method for ArrayOfSendCustomerCharacteristic
     * @uses ArrayOfSendCustomerCharacteristic::setSendCustomerCharacteristic()
     * @param \StructType\SendCustomerCharacteristic[] $sendCustomerCharacteristic
     */
    public function __construct(array $sendCustomerCharacteristic = array())
    {
        $this
            ->setSendCustomerCharacteristic($sendCustomerCharacteristic);
    }
    /**
     * Get SendCustomerCharacteristic value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SendCustomerCharacteristic[]|null
     */
    public function getSendCustomerCharacteristic()
    {
        return isset($this->SendCustomerCharacteristic) ? $this->SendCustomerCharacteristic : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSendCustomerCharacteristic method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSendCustomerCharacteristic method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSendCustomerCharacteristicForArrayConstraintsFromSetSendCustomerCharacteristic(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSendCustomerCharacteristicSendCustomerCharacteristicItem) {
            // validation for constraint: itemType
            if (!$arrayOfSendCustomerCharacteristicSendCustomerCharacteristicItem instanceof \StructType\SendCustomerCharacteristic) {
                $invalidValues[] = is_object($arrayOfSendCustomerCharacteristicSendCustomerCharacteristicItem) ? get_class($arrayOfSendCustomerCharacteristicSendCustomerCharacteristicItem) : sprintf('%s(%s)', gettype($arrayOfSendCustomerCharacteristicSendCustomerCharacteristicItem), var_export($arrayOfSendCustomerCharacteristicSendCustomerCharacteristicItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SendCustomerCharacteristic property can only contain items of type \StructType\SendCustomerCharacteristic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SendCustomerCharacteristic value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SendCustomerCharacteristic[] $sendCustomerCharacteristic
     * @return \ArrayType\ArrayOfSendCustomerCharacteristic
     */
    public function setSendCustomerCharacteristic(array $sendCustomerCharacteristic = array())
    {
        // validation for constraint: array
        if ('' !== ($sendCustomerCharacteristicArrayErrorMessage = self::validateSendCustomerCharacteristicForArrayConstraintsFromSetSendCustomerCharacteristic($sendCustomerCharacteristic))) {
            throw new \InvalidArgumentException($sendCustomerCharacteristicArrayErrorMessage, __LINE__);
        }
        if (is_null($sendCustomerCharacteristic) || (is_array($sendCustomerCharacteristic) && empty($sendCustomerCharacteristic))) {
            unset($this->SendCustomerCharacteristic);
        } else {
            $this->SendCustomerCharacteristic = $sendCustomerCharacteristic;
        }
        return $this;
    }
    /**
     * Add item to SendCustomerCharacteristic value
     * @throws \InvalidArgumentException
     * @param \StructType\SendCustomerCharacteristic $item
     * @return \ArrayType\ArrayOfSendCustomerCharacteristic
     */
    public function addToSendCustomerCharacteristic(\StructType\SendCustomerCharacteristic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SendCustomerCharacteristic) {
            throw new \InvalidArgumentException(sprintf('The SendCustomerCharacteristic property can only contain items of type \StructType\SendCustomerCharacteristic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SendCustomerCharacteristic[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SendCustomerCharacteristic|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SendCustomerCharacteristic|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SendCustomerCharacteristic|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SendCustomerCharacteristic|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SendCustomerCharacteristic|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SendCustomerCharacteristic
     */
    public function getAttributeName()
    {
        return 'SendCustomerCharacteristic';
    }
}
