<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSendOrderAdditionalCost ArrayType
 * @subpackage Arrays
 */
class ArrayOfSendOrderAdditionalCost extends AbstractStructArrayBase
{
    /**
     * The SendOrderAdditionalCost
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SendOrderAdditionalCost[]
     */
    public $SendOrderAdditionalCost;
    /**
     * Constructor method for ArrayOfSendOrderAdditionalCost
     * @uses ArrayOfSendOrderAdditionalCost::setSendOrderAdditionalCost()
     * @param \StructType\SendOrderAdditionalCost[] $sendOrderAdditionalCost
     */
    public function __construct(array $sendOrderAdditionalCost = array())
    {
        $this
            ->setSendOrderAdditionalCost($sendOrderAdditionalCost);
    }
    /**
     * Get SendOrderAdditionalCost value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SendOrderAdditionalCost[]|null
     */
    public function getSendOrderAdditionalCost()
    {
        return isset($this->SendOrderAdditionalCost) ? $this->SendOrderAdditionalCost : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSendOrderAdditionalCost method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSendOrderAdditionalCost method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSendOrderAdditionalCostForArrayConstraintsFromSetSendOrderAdditionalCost(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSendOrderAdditionalCostSendOrderAdditionalCostItem) {
            // validation for constraint: itemType
            if (!$arrayOfSendOrderAdditionalCostSendOrderAdditionalCostItem instanceof \StructType\SendOrderAdditionalCost) {
                $invalidValues[] = is_object($arrayOfSendOrderAdditionalCostSendOrderAdditionalCostItem) ? get_class($arrayOfSendOrderAdditionalCostSendOrderAdditionalCostItem) : sprintf('%s(%s)', gettype($arrayOfSendOrderAdditionalCostSendOrderAdditionalCostItem), var_export($arrayOfSendOrderAdditionalCostSendOrderAdditionalCostItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SendOrderAdditionalCost property can only contain items of type \StructType\SendOrderAdditionalCost, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SendOrderAdditionalCost value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SendOrderAdditionalCost[] $sendOrderAdditionalCost
     * @return \ArrayType\ArrayOfSendOrderAdditionalCost
     */
    public function setSendOrderAdditionalCost(array $sendOrderAdditionalCost = array())
    {
        // validation for constraint: array
        if ('' !== ($sendOrderAdditionalCostArrayErrorMessage = self::validateSendOrderAdditionalCostForArrayConstraintsFromSetSendOrderAdditionalCost($sendOrderAdditionalCost))) {
            throw new \InvalidArgumentException($sendOrderAdditionalCostArrayErrorMessage, __LINE__);
        }
        if (is_null($sendOrderAdditionalCost) || (is_array($sendOrderAdditionalCost) && empty($sendOrderAdditionalCost))) {
            unset($this->SendOrderAdditionalCost);
        } else {
            $this->SendOrderAdditionalCost = $sendOrderAdditionalCost;
        }
        return $this;
    }
    /**
     * Add item to SendOrderAdditionalCost value
     * @throws \InvalidArgumentException
     * @param \StructType\SendOrderAdditionalCost $item
     * @return \ArrayType\ArrayOfSendOrderAdditionalCost
     */
    public function addToSendOrderAdditionalCost(\StructType\SendOrderAdditionalCost $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SendOrderAdditionalCost) {
            throw new \InvalidArgumentException(sprintf('The SendOrderAdditionalCost property can only contain items of type \StructType\SendOrderAdditionalCost, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SendOrderAdditionalCost[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SendOrderAdditionalCost|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SendOrderAdditionalCost|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SendOrderAdditionalCost|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SendOrderAdditionalCost|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SendOrderAdditionalCost|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SendOrderAdditionalCost
     */
    public function getAttributeName()
    {
        return 'SendOrderAdditionalCost';
    }
}
