<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSendOrderPosition ArrayType
 * @subpackage Arrays
 */
class ArrayOfSendOrderPosition extends AbstractStructArrayBase
{
    /**
     * The SendOrderPosition
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SendOrderPosition[]
     */
    public $SendOrderPosition;
    /**
     * Constructor method for ArrayOfSendOrderPosition
     * @uses ArrayOfSendOrderPosition::setSendOrderPosition()
     * @param \StructType\SendOrderPosition[] $sendOrderPosition
     */
    public function __construct(array $sendOrderPosition = array())
    {
        $this
            ->setSendOrderPosition($sendOrderPosition);
    }
    /**
     * Get SendOrderPosition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SendOrderPosition[]|null
     */
    public function getSendOrderPosition()
    {
        return isset($this->SendOrderPosition) ? $this->SendOrderPosition : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSendOrderPosition method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSendOrderPosition method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSendOrderPositionForArrayConstraintsFromSetSendOrderPosition(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSendOrderPositionSendOrderPositionItem) {
            // validation for constraint: itemType
            if (!$arrayOfSendOrderPositionSendOrderPositionItem instanceof \StructType\SendOrderPosition) {
                $invalidValues[] = is_object($arrayOfSendOrderPositionSendOrderPositionItem) ? get_class($arrayOfSendOrderPositionSendOrderPositionItem) : sprintf('%s(%s)', gettype($arrayOfSendOrderPositionSendOrderPositionItem), var_export($arrayOfSendOrderPositionSendOrderPositionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SendOrderPosition property can only contain items of type \StructType\SendOrderPosition, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SendOrderPosition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SendOrderPosition[] $sendOrderPosition
     * @return \ArrayType\ArrayOfSendOrderPosition
     */
    public function setSendOrderPosition(array $sendOrderPosition = array())
    {
        // validation for constraint: array
        if ('' !== ($sendOrderPositionArrayErrorMessage = self::validateSendOrderPositionForArrayConstraintsFromSetSendOrderPosition($sendOrderPosition))) {
            throw new \InvalidArgumentException($sendOrderPositionArrayErrorMessage, __LINE__);
        }
        if (is_null($sendOrderPosition) || (is_array($sendOrderPosition) && empty($sendOrderPosition))) {
            unset($this->SendOrderPosition);
        } else {
            $this->SendOrderPosition = $sendOrderPosition;
        }
        return $this;
    }
    /**
     * Add item to SendOrderPosition value
     * @throws \InvalidArgumentException
     * @param \StructType\SendOrderPosition $item
     * @return \ArrayType\ArrayOfSendOrderPosition
     */
    public function addToSendOrderPosition(\StructType\SendOrderPosition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SendOrderPosition) {
            throw new \InvalidArgumentException(sprintf('The SendOrderPosition property can only contain items of type \StructType\SendOrderPosition, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SendOrderPosition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SendOrderPosition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SendOrderPosition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SendOrderPosition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SendOrderPosition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SendOrderPosition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SendOrderPosition
     */
    public function getAttributeName()
    {
        return 'SendOrderPosition';
    }
}
