<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSendStockCorrectionDetailRequest ArrayType
 * @subpackage Arrays
 */
class ArrayOfSendStockCorrectionDetailRequest extends AbstractStructArrayBase
{
    /**
     * The SendStockCorrectionDetailRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SendStockCorrectionDetailRequest[]
     */
    public $SendStockCorrectionDetailRequest;
    /**
     * Constructor method for ArrayOfSendStockCorrectionDetailRequest
     * @uses ArrayOfSendStockCorrectionDetailRequest::setSendStockCorrectionDetailRequest()
     * @param \StructType\SendStockCorrectionDetailRequest[] $sendStockCorrectionDetailRequest
     */
    public function __construct(array $sendStockCorrectionDetailRequest = array())
    {
        $this
            ->setSendStockCorrectionDetailRequest($sendStockCorrectionDetailRequest);
    }
    /**
     * Get SendStockCorrectionDetailRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SendStockCorrectionDetailRequest[]|null
     */
    public function getSendStockCorrectionDetailRequest()
    {
        return isset($this->SendStockCorrectionDetailRequest) ? $this->SendStockCorrectionDetailRequest : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSendStockCorrectionDetailRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSendStockCorrectionDetailRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSendStockCorrectionDetailRequestForArrayConstraintsFromSetSendStockCorrectionDetailRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSendStockCorrectionDetailRequestSendStockCorrectionDetailRequestItem) {
            // validation for constraint: itemType
            if (!$arrayOfSendStockCorrectionDetailRequestSendStockCorrectionDetailRequestItem instanceof \StructType\SendStockCorrectionDetailRequest) {
                $invalidValues[] = is_object($arrayOfSendStockCorrectionDetailRequestSendStockCorrectionDetailRequestItem) ? get_class($arrayOfSendStockCorrectionDetailRequestSendStockCorrectionDetailRequestItem) : sprintf('%s(%s)', gettype($arrayOfSendStockCorrectionDetailRequestSendStockCorrectionDetailRequestItem), var_export($arrayOfSendStockCorrectionDetailRequestSendStockCorrectionDetailRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SendStockCorrectionDetailRequest property can only contain items of type \StructType\SendStockCorrectionDetailRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SendStockCorrectionDetailRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SendStockCorrectionDetailRequest[] $sendStockCorrectionDetailRequest
     * @return \ArrayType\ArrayOfSendStockCorrectionDetailRequest
     */
    public function setSendStockCorrectionDetailRequest(array $sendStockCorrectionDetailRequest = array())
    {
        // validation for constraint: array
        if ('' !== ($sendStockCorrectionDetailRequestArrayErrorMessage = self::validateSendStockCorrectionDetailRequestForArrayConstraintsFromSetSendStockCorrectionDetailRequest($sendStockCorrectionDetailRequest))) {
            throw new \InvalidArgumentException($sendStockCorrectionDetailRequestArrayErrorMessage, __LINE__);
        }
        if (is_null($sendStockCorrectionDetailRequest) || (is_array($sendStockCorrectionDetailRequest) && empty($sendStockCorrectionDetailRequest))) {
            unset($this->SendStockCorrectionDetailRequest);
        } else {
            $this->SendStockCorrectionDetailRequest = $sendStockCorrectionDetailRequest;
        }
        return $this;
    }
    /**
     * Add item to SendStockCorrectionDetailRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\SendStockCorrectionDetailRequest $item
     * @return \ArrayType\ArrayOfSendStockCorrectionDetailRequest
     */
    public function addToSendStockCorrectionDetailRequest(\StructType\SendStockCorrectionDetailRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SendStockCorrectionDetailRequest) {
            throw new \InvalidArgumentException(sprintf('The SendStockCorrectionDetailRequest property can only contain items of type \StructType\SendStockCorrectionDetailRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SendStockCorrectionDetailRequest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SendStockCorrectionDetailRequest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SendStockCorrectionDetailRequest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SendStockCorrectionDetailRequest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SendStockCorrectionDetailRequest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SendStockCorrectionDetailRequest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SendStockCorrectionDetailRequest
     */
    public function getAttributeName()
    {
        return 'SendStockCorrectionDetailRequest';
    }
}
