<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSystemColour ArrayType
 * @subpackage Arrays
 */
class ArrayOfSystemColour extends AbstractStructArrayBase
{
    /**
     * The SystemColour
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SystemColour[]
     */
    public $SystemColour;
    /**
     * Constructor method for ArrayOfSystemColour
     * @uses ArrayOfSystemColour::setSystemColour()
     * @param \StructType\SystemColour[] $systemColour
     */
    public function __construct(array $systemColour = array())
    {
        $this
            ->setSystemColour($systemColour);
    }
    /**
     * Get SystemColour value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SystemColour[]|null
     */
    public function getSystemColour()
    {
        return isset($this->SystemColour) ? $this->SystemColour : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSystemColour method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSystemColour method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSystemColourForArrayConstraintsFromSetSystemColour(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSystemColourSystemColourItem) {
            // validation for constraint: itemType
            if (!$arrayOfSystemColourSystemColourItem instanceof \StructType\SystemColour) {
                $invalidValues[] = is_object($arrayOfSystemColourSystemColourItem) ? get_class($arrayOfSystemColourSystemColourItem) : sprintf('%s(%s)', gettype($arrayOfSystemColourSystemColourItem), var_export($arrayOfSystemColourSystemColourItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SystemColour property can only contain items of type \StructType\SystemColour, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SystemColour value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SystemColour[] $systemColour
     * @return \ArrayType\ArrayOfSystemColour
     */
    public function setSystemColour(array $systemColour = array())
    {
        // validation for constraint: array
        if ('' !== ($systemColourArrayErrorMessage = self::validateSystemColourForArrayConstraintsFromSetSystemColour($systemColour))) {
            throw new \InvalidArgumentException($systemColourArrayErrorMessage, __LINE__);
        }
        if (is_null($systemColour) || (is_array($systemColour) && empty($systemColour))) {
            unset($this->SystemColour);
        } else {
            $this->SystemColour = $systemColour;
        }
        return $this;
    }
    /**
     * Add item to SystemColour value
     * @throws \InvalidArgumentException
     * @param \StructType\SystemColour $item
     * @return \ArrayType\ArrayOfSystemColour
     */
    public function addToSystemColour(\StructType\SystemColour $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SystemColour) {
            throw new \InvalidArgumentException(sprintf('The SystemColour property can only contain items of type \StructType\SystemColour, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SystemColour[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SystemColour|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SystemColour|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SystemColour|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SystemColour|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SystemColour|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SystemColour
     */
    public function getAttributeName()
    {
        return 'SystemColour';
    }
}
