<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUpdateIbtDetailRequest ArrayType
 * @subpackage Arrays
 */
class ArrayOfUpdateIbtDetailRequest extends AbstractStructArrayBase
{
    /**
     * The UpdateIbtDetailRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UpdateIbtDetailRequest[]
     */
    public $UpdateIbtDetailRequest;
    /**
     * Constructor method for ArrayOfUpdateIbtDetailRequest
     * @uses ArrayOfUpdateIbtDetailRequest::setUpdateIbtDetailRequest()
     * @param \StructType\UpdateIbtDetailRequest[] $updateIbtDetailRequest
     */
    public function __construct(array $updateIbtDetailRequest = array())
    {
        $this
            ->setUpdateIbtDetailRequest($updateIbtDetailRequest);
    }
    /**
     * Get UpdateIbtDetailRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UpdateIbtDetailRequest[]|null
     */
    public function getUpdateIbtDetailRequest()
    {
        return isset($this->UpdateIbtDetailRequest) ? $this->UpdateIbtDetailRequest : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUpdateIbtDetailRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpdateIbtDetailRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpdateIbtDetailRequestForArrayConstraintsFromSetUpdateIbtDetailRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUpdateIbtDetailRequestUpdateIbtDetailRequestItem) {
            // validation for constraint: itemType
            if (!$arrayOfUpdateIbtDetailRequestUpdateIbtDetailRequestItem instanceof \StructType\UpdateIbtDetailRequest) {
                $invalidValues[] = is_object($arrayOfUpdateIbtDetailRequestUpdateIbtDetailRequestItem) ? get_class($arrayOfUpdateIbtDetailRequestUpdateIbtDetailRequestItem) : sprintf('%s(%s)', gettype($arrayOfUpdateIbtDetailRequestUpdateIbtDetailRequestItem), var_export($arrayOfUpdateIbtDetailRequestUpdateIbtDetailRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UpdateIbtDetailRequest property can only contain items of type \StructType\UpdateIbtDetailRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UpdateIbtDetailRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateIbtDetailRequest[] $updateIbtDetailRequest
     * @return \ArrayType\ArrayOfUpdateIbtDetailRequest
     */
    public function setUpdateIbtDetailRequest(array $updateIbtDetailRequest = array())
    {
        // validation for constraint: array
        if ('' !== ($updateIbtDetailRequestArrayErrorMessage = self::validateUpdateIbtDetailRequestForArrayConstraintsFromSetUpdateIbtDetailRequest($updateIbtDetailRequest))) {
            throw new \InvalidArgumentException($updateIbtDetailRequestArrayErrorMessage, __LINE__);
        }
        if (is_null($updateIbtDetailRequest) || (is_array($updateIbtDetailRequest) && empty($updateIbtDetailRequest))) {
            unset($this->UpdateIbtDetailRequest);
        } else {
            $this->UpdateIbtDetailRequest = $updateIbtDetailRequest;
        }
        return $this;
    }
    /**
     * Add item to UpdateIbtDetailRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateIbtDetailRequest $item
     * @return \ArrayType\ArrayOfUpdateIbtDetailRequest
     */
    public function addToUpdateIbtDetailRequest(\StructType\UpdateIbtDetailRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpdateIbtDetailRequest) {
            throw new \InvalidArgumentException(sprintf('The UpdateIbtDetailRequest property can only contain items of type \StructType\UpdateIbtDetailRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UpdateIbtDetailRequest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UpdateIbtDetailRequest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UpdateIbtDetailRequest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UpdateIbtDetailRequest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UpdateIbtDetailRequest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UpdateIbtDetailRequest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UpdateIbtDetailRequest
     */
    public function getAttributeName()
    {
        return 'UpdateIbtDetailRequest';
    }
}
