<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetAdditionalCostDefinitions' => '\\StructType\\GetAdditionalCostDefinitions',
            'AdditionalCostDefinitionRequest' => '\\StructType\\AdditionalCostDefinitionRequest',
            'BaseIDRequest' => '\\StructType\\BaseIDRequest',
            'GetAdditionalCostDefinitionsResponse' => '\\StructType\\GetAdditionalCostDefinitionsResponse',
            'AdditionalCostDefinitionResponse' => '\\StructType\\AdditionalCostDefinitionResponse',
            'BaseResponse' => '\\StructType\\BaseResponse',
            'TaskStatus' => '\\StructType\\TaskStatus',
            'ArrayOfTaskMessage' => '\\ArrayType\\ArrayOfTaskMessage',
            'TaskMessage' => '\\StructType\\TaskMessage',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'ArrayOfAdditionalCostDefinition' => '\\ArrayType\\ArrayOfAdditionalCostDefinition',
            'AdditionalCostDefinition' => '\\StructType\\AdditionalCostDefinition',
            'BaseContract_ID' => '\\StructType\\BaseContract_ID',
            'GetAddressTypes' => '\\StructType\\GetAddressTypes',
            'AddressTypeRequest' => '\\StructType\\AddressTypeRequest',
            'GetAddressTypesResponse' => '\\StructType\\GetAddressTypesResponse',
            'AddressTypeResponse' => '\\StructType\\AddressTypeResponse',
            'ArrayOfAddressType' => '\\ArrayType\\ArrayOfAddressType',
            'AddressType' => '\\StructType\\AddressType',
            'GetArticles' => '\\StructType\\GetArticles',
            'ArticleRequest' => '\\StructType\\ArticleRequest',
            'BaseIterationRequest' => '\\StructType\\BaseIterationRequest',
            'IterationConstraints' => '\\StructType\\IterationConstraints',
            'GetArticlesResponse' => '\\StructType\\GetArticlesResponse',
            'ArticleResponse' => '\\StructType\\ArticleResponse',
            'BaseIterationResponse' => '\\StructType\\BaseIterationResponse',
            'IterationStatus' => '\\StructType\\IterationStatus',
            'ArrayOfArticle' => '\\ArrayType\\ArrayOfArticle',
            'Article' => '\\StructType\\Article',
            'BaseContract_FullIDSet' => '\\StructType\\BaseContract_FullIDSet',
            'BaseContract_Oid' => '\\StructType\\BaseContract_Oid',
            'CharacteristicType' => '\\StructType\\CharacteristicType',
            'Characteristic' => '\\StructType\\Characteristic',
            'BankAccount' => '\\StructType\\BankAccount',
            'Branch' => '\\StructType\\Branch',
            'Person' => '\\StructType\\Person',
            'ArrayOfCommChannel' => '\\ArrayType\\ArrayOfCommChannel',
            'ArrayOfAddress' => '\\ArrayType\\ArrayOfAddress',
            'ArrayOfBankAccount' => '\\ArrayType\\ArrayOfBankAccount',
            'ArrayOfCustomerCard' => '\\ArrayType\\ArrayOfCustomerCard',
            'CustomerCard' => '\\StructType\\CustomerCard',
            'Manufacturer' => '\\StructType\\Manufacturer',
            'ProductGroup' => '\\StructType\\ProductGroup',
            'ArrayOfProductGroup' => '\\ArrayType\\ArrayOfProductGroup',
            'ArrayOfBranch' => '\\ArrayType\\ArrayOfBranch',
            'ArrayOfColorEanPrices' => '\\ArrayType\\ArrayOfColorEanPrices',
            'ColorEanPrices' => '\\StructType\\ColorEanPrices',
            'Color' => '\\StructType\\Color',
            'ArrayOfEanBranchPrices' => '\\ArrayType\\ArrayOfEanBranchPrices',
            'EanBranchPrices' => '\\StructType\\EanBranchPrices',
            'EanPriceBase' => '\\StructType\\EanPriceBase',
            'ArrayOfCharacteristic' => '\\ArrayType\\ArrayOfCharacteristic',
            'ArrayOfBranchPrice' => '\\ArrayType\\ArrayOfBranchPrice',
            'BranchPrice' => '\\StructType\\BranchPrice',
            'ArrayOfScanCode' => '\\ArrayType\\ArrayOfScanCode',
            'ScanCode' => '\\StructType\\ScanCode',
            'FindArticleByOid' => '\\StructType\\FindArticleByOid',
            'FindArticleRequest' => '\\StructType\\FindArticleRequest',
            'FindArticleByOidResponse' => '\\StructType\\FindArticleByOidResponse',
            'FindArticleResponse' => '\\StructType\\FindArticleResponse',
            'FindArticleByOidWithCharcteristics' => '\\StructType\\FindArticleByOidWithCharcteristics',
            'FindArticleByOidWithCharcteristicsResponse' => '\\StructType\\FindArticleByOidWithCharcteristicsResponse',
            'FindArticleByEanOid' => '\\StructType\\FindArticleByEanOid',
            'FindArticleByEanRequest' => '\\StructType\\FindArticleByEanRequest',
            'FindArticleByEanOidResponse' => '\\StructType\\FindArticleByEanOidResponse',
            'FindArticleByEanOidWithCharcteristics' => '\\StructType\\FindArticleByEanOidWithCharcteristics',
            'FindArticleByEanOidWithCharcteristicsResponse' => '\\StructType\\FindArticleByEanOidWithCharcteristicsResponse',
            'GetBranches' => '\\StructType\\GetBranches',
            'BranchRequest' => '\\StructType\\BranchRequest',
            'GetBranchesResponse' => '\\StructType\\GetBranchesResponse',
            'BranchResponse' => '\\StructType\\BranchResponse',
            'GetBrands' => '\\StructType\\GetBrands',
            'BrandRequest' => '\\StructType\\BrandRequest',
            'GetBrandsResponse' => '\\StructType\\GetBrandsResponse',
            'BrandResponse' => '\\StructType\\BrandResponse',
            'ArrayOfBrand' => '\\ArrayType\\ArrayOfBrand',
            'Brand' => '\\StructType\\Brand',
            'GetCharacteristics' => '\\StructType\\GetCharacteristics',
            'CharacteristicRequest' => '\\StructType\\CharacteristicRequest',
            'GetCharacteristicsResponse' => '\\StructType\\GetCharacteristicsResponse',
            'CharacteristicResponse' => '\\StructType\\CharacteristicResponse',
            'GetCharacteristicTypes' => '\\StructType\\GetCharacteristicTypes',
            'CharacteristicTypeRequest' => '\\StructType\\CharacteristicTypeRequest',
            'GetCharacteristicTypesResponse' => '\\StructType\\GetCharacteristicTypesResponse',
            'CharacteristicTypeResponse' => '\\StructType\\CharacteristicTypeResponse',
            'ArrayOfCharacteristicType' => '\\ArrayType\\ArrayOfCharacteristicType',
            'GetCountries' => '\\StructType\\GetCountries',
            'CountryRequest' => '\\StructType\\CountryRequest',
            'GetCountriesResponse' => '\\StructType\\GetCountriesResponse',
            'CountryResponse' => '\\StructType\\CountryResponse',
            'ArrayOfCountry' => '\\ArrayType\\ArrayOfCountry',
            'Country' => '\\StructType\\Country',
            'GetCurrencies' => '\\StructType\\GetCurrencies',
            'CurrencyRequest' => '\\StructType\\CurrencyRequest',
            'GetCurrenciesResponse' => '\\StructType\\GetCurrenciesResponse',
            'CurrencyResponse' => '\\StructType\\CurrencyResponse',
            'ArrayOfCurrency' => '\\ArrayType\\ArrayOfCurrency',
            'Currency' => '\\StructType\\Currency',
            'GetCustomers' => '\\StructType\\GetCustomers',
            'CustomerRequest' => '\\StructType\\CustomerRequest',
            'GetCustomersResponse' => '\\StructType\\GetCustomersResponse',
            'CustomerResponse' => '\\StructType\\CustomerResponse',
            'ArrayOfCustomer' => '\\ArrayType\\ArrayOfCustomer',
            'Customer' => '\\StructType\\Customer',
            'GetSystemCommChannelTypes' => '\\StructType\\GetSystemCommChannelTypes',
            'GetSystemCommChannelTypesResponse' => '\\StructType\\GetSystemCommChannelTypesResponse',
            'ArrayOfCommChannelType' => '\\ArrayType\\ArrayOfCommChannelType',
            'CommChannelType' => '\\StructType\\CommChannelType',
            'EntityContractBase' => '\\StructType\\EntityContractBase',
            'FindCustomerByOid' => '\\StructType\\FindCustomerByOid',
            'FindCustomerRequest' => '\\StructType\\FindCustomerRequest',
            'FindCustomerByOidResponse' => '\\StructType\\FindCustomerByOidResponse',
            'FindCustomerResponse' => '\\StructType\\FindCustomerResponse',
            'FindCustomersByParameter' => '\\StructType\\FindCustomersByParameter',
            'FindCustomersByParameterRequest' => '\\StructType\\FindCustomersByParameterRequest',
            'FindCustomersByParameterResponse' => '\\StructType\\FindCustomersByParameterResponse',
            'GetCustomerPurchaseHistory' => '\\StructType\\GetCustomerPurchaseHistory',
            'CustomerPurchaseHistoryRequest' => '\\StructType\\CustomerPurchaseHistoryRequest',
            'GetCustomerPurchaseHistoryResponse' => '\\StructType\\GetCustomerPurchaseHistoryResponse',
            'CustomerPurchaseHistoryResponse' => '\\StructType\\CustomerPurchaseHistoryResponse',
            'ArrayOfCustomerPurchaseHistory' => '\\ArrayType\\ArrayOfCustomerPurchaseHistory',
            'CustomerPurchaseHistory' => '\\StructType\\CustomerPurchaseHistory',
            'ArrayOfDiscount' => '\\ArrayType\\ArrayOfDiscount',
            'Discount' => '\\StructType\\Discount',
            'GetEmployees' => '\\StructType\\GetEmployees',
            'EmployeeRequest' => '\\StructType\\EmployeeRequest',
            'GetEmployeesResponse' => '\\StructType\\GetEmployeesResponse',
            'EmployeeResponse' => '\\StructType\\EmployeeResponse',
            'ArrayOfEmployee' => '\\ArrayType\\ArrayOfEmployee',
            'Employee' => '\\StructType\\Employee',
            'CustomerReference' => '\\StructType\\CustomerReference',
            'GetDiscountReasons' => '\\StructType\\GetDiscountReasons',
            'DiscountReasonRequest' => '\\StructType\\DiscountReasonRequest',
            'GetDiscountReasonsResponse' => '\\StructType\\GetDiscountReasonsResponse',
            'DiscountReasonResponse' => '\\StructType\\DiscountReasonResponse',
            'ArrayOfDiscountReason' => '\\ArrayType\\ArrayOfDiscountReason',
            'DiscountReason' => '\\StructType\\DiscountReason',
            'GetDeliveryNotes' => '\\StructType\\GetDeliveryNotes',
            'DeliveryNoteRequest' => '\\StructType\\DeliveryNoteRequest',
            'GetDeliveryNotesResponse' => '\\StructType\\GetDeliveryNotesResponse',
            'DeliveryNoteResponse' => '\\StructType\\DeliveryNoteResponse',
            'ArrayOfDeliveryNote' => '\\ArrayType\\ArrayOfDeliveryNote',
            'DeliveryNote' => '\\StructType\\DeliveryNote',
            'ArrayOfDeliveryNotePosition' => '\\ArrayType\\ArrayOfDeliveryNotePosition',
            'DeliveryNotePosition' => '\\StructType\\DeliveryNotePosition',
            'GetInvoices' => '\\StructType\\GetInvoices',
            'InvoiceRequest' => '\\StructType\\InvoiceRequest',
            'GetInvoicesResponse' => '\\StructType\\GetInvoicesResponse',
            'InvoiceResponse' => '\\StructType\\InvoiceResponse',
            'ArrayOfInvoice' => '\\ArrayType\\ArrayOfInvoice',
            'Invoice' => '\\StructType\\Invoice',
            'ArrayOfInvoicePosition' => '\\ArrayType\\ArrayOfInvoicePosition',
            'InvoicePosition' => '\\StructType\\InvoicePosition',
            'GetGoodsInAdvices' => '\\StructType\\GetGoodsInAdvices',
            'GetGoodsInAdvicesRequest' => '\\StructType\\GetGoodsInAdvicesRequest',
            'GetGoodsInAdvicesResponse' => '\\StructType\\GetGoodsInAdvicesResponse',
            'GetGoodsInAdviceResponse' => '\\StructType\\GetGoodsInAdviceResponse',
            'ArrayOfGoodsInAdvice' => '\\ArrayType\\ArrayOfGoodsInAdvice',
            'GoodsInAdvice' => '\\StructType\\GoodsInAdvice',
            'ArrayOfGoodsInAdviceDetail' => '\\ArrayType\\ArrayOfGoodsInAdviceDetail',
            'GoodsInAdviceDetail' => '\\StructType\\GoodsInAdviceDetail',
            'SendGoodsInAdviceConfirmation' => '\\StructType\\SendGoodsInAdviceConfirmation',
            'SendGoodsInAdviceConfirmationRequest' => '\\StructType\\SendGoodsInAdviceConfirmationRequest',
            'ArrayOfGoodsInAdviceDetailRequest' => '\\ArrayType\\ArrayOfGoodsInAdviceDetailRequest',
            'GoodsInAdviceDetailRequest' => '\\StructType\\GoodsInAdviceDetailRequest',
            'SendGoodsInAdviceConfirmationResponse' => '\\StructType\\SendGoodsInAdviceConfirmationResponse',
            'GetManufacturerColours' => '\\StructType\\GetManufacturerColours',
            'ManufacturerColourRequest' => '\\StructType\\ManufacturerColourRequest',
            'GetManufacturerColoursResponse' => '\\StructType\\GetManufacturerColoursResponse',
            'ManufacturerColourResponse' => '\\StructType\\ManufacturerColourResponse',
            'ArrayOfManufacturerColour' => '\\ArrayType\\ArrayOfManufacturerColour',
            'ManufacturerColour' => '\\StructType\\ManufacturerColour',
            'SystemColour' => '\\StructType\\SystemColour',
            'GetManufacturers' => '\\StructType\\GetManufacturers',
            'ManufacturerRequest' => '\\StructType\\ManufacturerRequest',
            'GetManufacturersResponse' => '\\StructType\\GetManufacturersResponse',
            'ManufacturerResponse' => '\\StructType\\ManufacturerResponse',
            'ArrayOfManufacturer' => '\\ArrayType\\ArrayOfManufacturer',
            'GetOrders' => '\\StructType\\GetOrders',
            'OrderRequest' => '\\StructType\\OrderRequest',
            'GetOrdersResponse' => '\\StructType\\GetOrdersResponse',
            'OrderResponse' => '\\StructType\\OrderResponse',
            'ArrayOfOrder' => '\\ArrayType\\ArrayOfOrder',
            'Order' => '\\StructType\\Order',
            'Address' => '\\StructType\\Address',
            'ArrayOfOrderPosition' => '\\ArrayType\\ArrayOfOrderPosition',
            'OrderPosition' => '\\StructType\\OrderPosition',
            'ArrayOfAdditionalCost' => '\\ArrayType\\ArrayOfAdditionalCost',
            'AdditionalCost' => '\\StructType\\AdditionalCost',
            'ArrayOfOrderStockPosition' => '\\ArrayType\\ArrayOfOrderStockPosition',
            'OrderStockPosition' => '\\StructType\\OrderStockPosition',
            'GetOpenOrderStock' => '\\StructType\\GetOpenOrderStock',
            'OrderStockRequest' => '\\StructType\\OrderStockRequest',
            'GetOpenOrderStockResponse' => '\\StructType\\GetOpenOrderStockResponse',
            'OrderStockResponse' => '\\StructType\\OrderStockResponse',
            'ArrayOfOrderStock' => '\\ArrayType\\ArrayOfOrderStock',
            'OrderStock' => '\\StructType\\OrderStock',
            'GetLanguages' => '\\StructType\\GetLanguages',
            'LanguageRequest' => '\\StructType\\LanguageRequest',
            'GetLanguagesResponse' => '\\StructType\\GetLanguagesResponse',
            'LanguageResponse' => '\\StructType\\LanguageResponse',
            'ArrayOfLanguage' => '\\ArrayType\\ArrayOfLanguage',
            'Language' => '\\StructType\\Language',
            'GetPaymentTypes' => '\\StructType\\GetPaymentTypes',
            'PaymentTypeRequest' => '\\StructType\\PaymentTypeRequest',
            'GetPaymentTypesResponse' => '\\StructType\\GetPaymentTypesResponse',
            'PaymentTypeResponse' => '\\StructType\\PaymentTypeResponse',
            'ArrayOfPaymentType' => '\\ArrayType\\ArrayOfPaymentType',
            'PaymentType' => '\\StructType\\PaymentType',
            'GetProductGroups' => '\\StructType\\GetProductGroups',
            'ProductGroupRequest' => '\\StructType\\ProductGroupRequest',
            'GetProductGroupsResponse' => '\\StructType\\GetProductGroupsResponse',
            'ProductGroupResponse' => '\\StructType\\ProductGroupResponse',
            'GetSalutations' => '\\StructType\\GetSalutations',
            'SalutationRequest' => '\\StructType\\SalutationRequest',
            'GetSalutationsResponse' => '\\StructType\\GetSalutationsResponse',
            'SalutationResponse' => '\\StructType\\SalutationResponse',
            'ArrayOfSalutation' => '\\ArrayType\\ArrayOfSalutation',
            'Salutation' => '\\StructType\\Salutation',
            'GetShops' => '\\StructType\\GetShops',
            'ShopRequest' => '\\StructType\\ShopRequest',
            'GetShopsResponse' => '\\StructType\\GetShopsResponse',
            'ShopResponse' => '\\StructType\\ShopResponse',
            'ArrayOfShop' => '\\ArrayType\\ArrayOfShop',
            'Shop' => '\\StructType\\Shop',
            'BookingPlace' => '\\StructType\\BookingPlace',
            'GetSizes' => '\\StructType\\GetSizes',
            'SizeRequest' => '\\StructType\\SizeRequest',
            'GetSizesResponse' => '\\StructType\\GetSizesResponse',
            'SizeResponse' => '\\StructType\\SizeResponse',
            'ArrayOfSize' => '\\ArrayType\\ArrayOfSize',
            'Size' => '\\StructType\\Size',
            'GetSizeRanges' => '\\StructType\\GetSizeRanges',
            'SizeRangeRequest' => '\\StructType\\SizeRangeRequest',
            'GetSizeRangesResponse' => '\\StructType\\GetSizeRangesResponse',
            'SizeRangeResponse' => '\\StructType\\SizeRangeResponse',
            'ArrayOfSizeRange' => '\\ArrayType\\ArrayOfSizeRange',
            'SizeRange' => '\\StructType\\SizeRange',
            'GetStocks' => '\\StructType\\GetStocks',
            'StockRequest' => '\\StructType\\StockRequest',
            'GetStocksResponse' => '\\StructType\\GetStocksResponse',
            'StockResponse' => '\\StructType\\StockResponse',
            'ArrayOfStockInfo' => '\\ArrayType\\ArrayOfStockInfo',
            'StockInfo' => '\\StructType\\StockInfo',
            'FindStockByArticleOid' => '\\StructType\\FindStockByArticleOid',
            'FindStockByArticleOidRequest' => '\\StructType\\FindStockByArticleOidRequest',
            'FindStockByArticleOidResponse' => '\\StructType\\FindStockByArticleOidResponse',
            'FindStockResponse' => '\\StructType\\FindStockResponse',
            'FindStockByEanOid' => '\\StructType\\FindStockByEanOid',
            'FindStockByEanOidRequest' => '\\StructType\\FindStockByEanOidRequest',
            'FindStockByEanOidResponse' => '\\StructType\\FindStockByEanOidResponse',
            'SendStockCorrection' => '\\StructType\\SendStockCorrection',
            'SendStockCorrectionRequest' => '\\StructType\\SendStockCorrectionRequest',
            'ArrayOfSendStockCorrectionDetailRequest' => '\\ArrayType\\ArrayOfSendStockCorrectionDetailRequest',
            'SendStockCorrectionDetailRequest' => '\\StructType\\SendStockCorrectionDetailRequest',
            'SendStockCorrectionResponse' => '\\StructType\\SendStockCorrectionResponse',
            'GetSystemColours' => '\\StructType\\GetSystemColours',
            'SystemColourRequest' => '\\StructType\\SystemColourRequest',
            'GetSystemColoursResponse' => '\\StructType\\GetSystemColoursResponse',
            'SystemColourResponse' => '\\StructType\\SystemColourResponse',
            'ArrayOfSystemColour' => '\\ArrayType\\ArrayOfSystemColour',
            'GetVats' => '\\StructType\\GetVats',
            'VatRequest' => '\\StructType\\VatRequest',
            'GetVatsResponse' => '\\StructType\\GetVatsResponse',
            'VatResponse' => '\\StructType\\VatResponse',
            'ArrayOfVat' => '\\ArrayType\\ArrayOfVat',
            'Vat' => '\\StructType\\Vat',
            'GetVouchers' => '\\StructType\\GetVouchers',
            'VoucherRequest' => '\\StructType\\VoucherRequest',
            'GetVouchersResponse' => '\\StructType\\GetVouchersResponse',
            'VoucherResponse' => '\\StructType\\VoucherResponse',
            'ArrayOfVoucher' => '\\ArrayType\\ArrayOfVoucher',
            'Voucher' => '\\StructType\\Voucher',
            'GetDeletedObjectsIterated' => '\\StructType\\GetDeletedObjectsIterated',
            'DeletedObjectsIterationRequest' => '\\StructType\\DeletedObjectsIterationRequest',
            'GetDeletedObjectsIteratedResponse' => '\\StructType\\GetDeletedObjectsIteratedResponse',
            'DeletedObjectsIterationResponse' => '\\StructType\\DeletedObjectsIterationResponse',
            'ArrayOfDeletedObjectReference' => '\\ArrayType\\ArrayOfDeletedObjectReference',
            'DeletedObjectReference' => '\\StructType\\DeletedObjectReference',
            'CheckDeletedObject' => '\\StructType\\CheckDeletedObject',
            'CheckDeletedObjectRequest' => '\\StructType\\CheckDeletedObjectRequest',
            'BaseRequest' => '\\StructType\\BaseRequest',
            'ExtensionDataObject' => '\\StructType\\ExtensionDataObject',
            'CheckDeletedObjectResponse' => '\\StructType\\CheckDeletedObjectResponse',
            'SendCustomer' => '\\StructType\\SendCustomer',
            'SendCustomerRequest' => '\\StructType\\SendCustomerRequest',
            'ArrayOfSendCustomerCharacteristic' => '\\ArrayType\\ArrayOfSendCustomerCharacteristic',
            'SendCustomerCharacteristic' => '\\StructType\\SendCustomerCharacteristic',
            'SendCustomerResponse' => '\\StructType\\SendCustomerResponse',
            'SendDeliveryNotes' => '\\StructType\\SendDeliveryNotes',
            'SendDeliveryNoteRequest' => '\\StructType\\SendDeliveryNoteRequest',
            'SendDeliveryNotesResponse' => '\\StructType\\SendDeliveryNotesResponse',
            'SendDeliveryNoteResponse' => '\\StructType\\SendDeliveryNoteResponse',
            'SendInvoices' => '\\StructType\\SendInvoices',
            'SendInvoiceRequest' => '\\StructType\\SendInvoiceRequest',
            'SendInvoicesResponse' => '\\StructType\\SendInvoicesResponse',
            'SendInvoiceResponse' => '\\StructType\\SendInvoiceResponse',
            'SendOrders' => '\\StructType\\SendOrders',
            'SendOrdersResponse' => '\\StructType\\SendOrdersResponse',
            'SendOrderResponse' => '\\StructType\\SendOrderResponse',
            'SendVouchers' => '\\StructType\\SendVouchers',
            'SendVoucherRequest' => '\\StructType\\SendVoucherRequest',
            'SendVouchersResponse' => '\\StructType\\SendVouchersResponse',
            'SendVoucherResponse' => '\\StructType\\SendVoucherResponse',
            'SendSalesReceipt' => '\\StructType\\SendSalesReceipt',
            'SendSalesReceiptRequest' => '\\StructType\\SendSalesReceiptRequest',
            'ArrayOfSalesReceiptPosition' => '\\ArrayType\\ArrayOfSalesReceiptPosition',
            'SalesReceiptPosition' => '\\StructType\\SalesReceiptPosition',
            'ArrayOfTextInfo' => '\\ArrayType\\ArrayOfTextInfo',
            'TextInfo' => '\\StructType\\TextInfo',
            'SendSalesReceiptResponse' => '\\StructType\\SendSalesReceiptResponse',
            'SalesReceiptResponse' => '\\StructType\\SalesReceiptResponse',
            'ArrayOfSalesReceipt' => '\\ArrayType\\ArrayOfSalesReceipt',
            'SalesReceipt' => '\\StructType\\SalesReceipt',
            'GetStatus' => '\\StructType\\GetStatus',
            'StatusRequest' => '\\StructType\\StatusRequest',
            'GetStatusResponse' => '\\StructType\\GetStatusResponse',
            'StatusResponse' => '\\StructType\\StatusResponse',
            'ServiceStatus' => '\\StructType\\ServiceStatus',
            'ComponentConfiguration' => '\\StructType\\ComponentConfiguration',
            'ArrayOfConfigurationEntry' => '\\ArrayType\\ArrayOfConfigurationEntry',
            'ConfigurationEntry' => '\\StructType\\ConfigurationEntry',
            'ArrayOfServiceReference' => '\\ArrayType\\ArrayOfServiceReference',
            'ServiceReference' => '\\StructType\\ServiceReference',
            'UpdateIbt' => '\\StructType\\UpdateIbt',
            'UpdateIbtRequest' => '\\StructType\\UpdateIbtRequest',
            'ArrayOfUpdateIbtDetailRequest' => '\\ArrayType\\ArrayOfUpdateIbtDetailRequest',
            'UpdateIbtDetailRequest' => '\\StructType\\UpdateIbtDetailRequest',
            'UpdateIbtResponse' => '\\StructType\\UpdateIbtResponse',
            'InterBranchTransferHead' => '\\StructType\\InterBranchTransferHead',
            'ArrayOfInterBranchTransferDetail' => '\\ArrayType\\ArrayOfInterBranchTransferDetail',
            'InterBranchTransferDetail' => '\\StructType\\InterBranchTransferDetail',
            'ReceiveIbt' => '\\StructType\\ReceiveIbt',
            'ReceiveIbtResponse' => '\\StructType\\ReceiveIbtResponse',
            'CreateIbt' => '\\StructType\\CreateIbt',
            'IbtCreatorRequest' => '\\StructType\\IbtCreatorRequest',
            'IbtAdviceData' => '\\StructType\\IbtAdviceData',
            'PostCreationAction' => '\\StructType\\PostCreationAction',
            'ArrayOfIbtDetailRequest' => '\\ArrayType\\ArrayOfIbtDetailRequest',
            'IbtDetailRequest' => '\\StructType\\IbtDetailRequest',
            'CreateIbtResponse' => '\\StructType\\CreateIbtResponse',
            'IbtCreatorResponse' => '\\StructType\\IbtCreatorResponse',
            'BaseCreatorResponse' => '\\StructType\\BaseCreatorResponse',
            'GetIbts' => '\\StructType\\GetIbts',
            'GetIbtsRequest' => '\\StructType\\GetIbtsRequest',
            'GetIbtsResponse' => '\\StructType\\GetIbtsResponse',
            'ArrayOfInterBranchTransferHead' => '\\ArrayType\\ArrayOfInterBranchTransferHead',
            'GetReturnReasons' => '\\StructType\\GetReturnReasons',
            'ReturnReasonRequest' => '\\StructType\\ReturnReasonRequest',
            'GetReturnReasonsResponse' => '\\StructType\\GetReturnReasonsResponse',
            'ReturnReasonResponse' => '\\StructType\\ReturnReasonResponse',
            'ArrayOfReturnReason' => '\\ArrayType\\ArrayOfReturnReason',
            'ReturnReason' => '\\StructType\\ReturnReason',
            'AddressBook' => '\\StructType\\AddressBook',
            'VoidableEntityContractBase' => '\\StructType\\VoidableEntityContractBase',
            'CommChannel' => '\\StructType\\CommChannel',
            'SendOrderRequest' => '\\StructType\\SendOrderRequest',
            'SendOrderAddress' => '\\StructType\\SendOrderAddress',
            'ArrayOfSendOrderPosition' => '\\ArrayType\\ArrayOfSendOrderPosition',
            'SendOrderPosition' => '\\StructType\\SendOrderPosition',
            'ArrayOfSendOrderAdditionalCost' => '\\ArrayType\\ArrayOfSendOrderAdditionalCost',
            'SendOrderAdditionalCost' => '\\StructType\\SendOrderAdditionalCost',
        );
    }
}
