<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ArticleResponse StructType
 * @subpackage Structs
 */
class ArticleResponse extends BaseIterationResponse
{
    /**
     * The Articles
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfArticle
     */
    public $Articles;
    /**
     * Constructor method for ArticleResponse
     * @uses ArticleResponse::setArticles()
     * @param \ArrayType\ArrayOfArticle $articles
     */
    public function __construct(\ArrayType\ArrayOfArticle $articles = null)
    {
        $this
            ->setArticles($articles);
    }
    /**
     * Get Articles value
     * @return \ArrayType\ArrayOfArticle|null
     */
    public function getArticles()
    {
        return $this->Articles;
    }
    /**
     * Set Articles value
     * @param \ArrayType\ArrayOfArticle $articles
     * @return \StructType\ArticleResponse
     */
    public function setArticles(\ArrayType\ArrayOfArticle $articles = null)
    {
        $this->Articles = $articles;
        return $this;
    }
}
