<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EntityContractBase StructType
 * @subpackage Structs
 */
abstract class EntityContractBase extends AbstractStructBase
{
    /**
     * The Oid
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Oid;
    /**
     * Constructor method for EntityContractBase
     * @uses EntityContractBase::setOid()
     * @param string $oid
     */
    public function __construct($oid = null)
    {
        $this
            ->setOid($oid);
    }
    /**
     * Get Oid value
     * @return string|null
     */
    public function getOid()
    {
        return $this->Oid;
    }
    /**
     * Set Oid value
     * @param string $oid
     * @return \StructType\EntityContractBase
     */
    public function setOid($oid = null)
    {
        // validation for constraint: string
        if (!is_null($oid) && !is_string($oid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($oid, true), gettype($oid)), __LINE__);
        }
        $this->Oid = $oid;
        return $this;
    }
}
