<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProductGroupRequest StructType
 * @subpackage Structs
 */
class ProductGroupRequest extends BaseIterationRequest
{
    /**
     * The ReturnHierarchy
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $ReturnHierarchy;
    /**
     * The LongNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LongNumber;
    /**
     * Constructor method for ProductGroupRequest
     * @uses ProductGroupRequest::setReturnHierarchy()
     * @uses ProductGroupRequest::setLongNumber()
     * @param bool $returnHierarchy
     * @param string $longNumber
     */
    public function __construct($returnHierarchy = null, $longNumber = null)
    {
        $this
            ->setReturnHierarchy($returnHierarchy)
            ->setLongNumber($longNumber);
    }
    /**
     * Get ReturnHierarchy value
     * @return bool
     */
    public function getReturnHierarchy()
    {
        return $this->ReturnHierarchy;
    }
    /**
     * Set ReturnHierarchy value
     * @param bool $returnHierarchy
     * @return \StructType\ProductGroupRequest
     */
    public function setReturnHierarchy($returnHierarchy = null)
    {
        // validation for constraint: boolean
        if (!is_null($returnHierarchy) && !is_bool($returnHierarchy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($returnHierarchy, true), gettype($returnHierarchy)), __LINE__);
        }
        $this->ReturnHierarchy = $returnHierarchy;
        return $this;
    }
    /**
     * Get LongNumber value
     * @return string|null
     */
    public function getLongNumber()
    {
        return $this->LongNumber;
    }
    /**
     * Set LongNumber value
     * @param string $longNumber
     * @return \StructType\ProductGroupRequest
     */
    public function setLongNumber($longNumber = null)
    {
        // validation for constraint: string
        if (!is_null($longNumber) && !is_string($longNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($longNumber, true), gettype($longNumber)), __LINE__);
        }
        $this->LongNumber = $longNumber;
        return $this;
    }
}
