<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendCustomerCharacteristic StructType
 * @subpackage Structs
 */
class SendCustomerCharacteristic extends AbstractStructBase
{
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ID;
    /**
     * The Fraction
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Fraction;
    /**
     * Constructor method for SendCustomerCharacteristic
     * @uses SendCustomerCharacteristic::setID()
     * @uses SendCustomerCharacteristic::setFraction()
     * @param int $iD
     * @param float $fraction
     */
    public function __construct($iD = null, $fraction = null)
    {
        $this
            ->setID($iD)
            ->setFraction($fraction);
    }
    /**
     * Get ID value
     * @return int
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \StructType\SendCustomerCharacteristic
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !(is_int($iD) || ctype_digit($iD))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Fraction value
     * @return float
     */
    public function getFraction()
    {
        return $this->Fraction;
    }
    /**
     * Set Fraction value
     * @param float $fraction
     * @return \StructType\SendCustomerCharacteristic
     */
    public function setFraction($fraction = null)
    {
        // validation for constraint: float
        if (!is_null($fraction) && !(is_float($fraction) || is_numeric($fraction))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($fraction, true), gettype($fraction)), __LINE__);
        }
        $this->Fraction = $fraction;
        return $this;
    }
}
