<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendGoodsInAdviceConfirmationResponse StructType
 * @subpackage Structs
 */
class SendGoodsInAdviceConfirmationResponse extends BaseIterationResponse
{
    /**
     * The CreationActionSuccess
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $CreationActionSuccess;
    /**
     * The SendGoodsInAdviceConfirmationResult
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SendGoodsInAdviceConfirmationResponse
     */
    public $SendGoodsInAdviceConfirmationResult;
    /**
     * The GoodsInAdvices
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfGoodsInAdvice
     */
    public $GoodsInAdvices;
    /**
     * The CreationErrorMessages
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $CreationErrorMessages;
    /**
     * Constructor method for SendGoodsInAdviceConfirmationResponse
     * @uses SendGoodsInAdviceConfirmationResponse::setCreationActionSuccess()
     * @uses SendGoodsInAdviceConfirmationResponse::setSendGoodsInAdviceConfirmationResult()
     * @uses SendGoodsInAdviceConfirmationResponse::setGoodsInAdvices()
     * @uses SendGoodsInAdviceConfirmationResponse::setCreationErrorMessages()
     * @param bool $creationActionSuccess
     * @param \StructType\SendGoodsInAdviceConfirmationResponse $sendGoodsInAdviceConfirmationResult
     * @param \ArrayType\ArrayOfGoodsInAdvice $goodsInAdvices
     * @param \ArrayType\ArrayOfString $creationErrorMessages
     */
    public function __construct($creationActionSuccess = null, \StructType\SendGoodsInAdviceConfirmationResponse $sendGoodsInAdviceConfirmationResult = null, \ArrayType\ArrayOfGoodsInAdvice $goodsInAdvices = null, \ArrayType\ArrayOfString $creationErrorMessages = null)
    {
        $this
            ->setCreationActionSuccess($creationActionSuccess)
            ->setSendGoodsInAdviceConfirmationResult($sendGoodsInAdviceConfirmationResult)
            ->setGoodsInAdvices($goodsInAdvices)
            ->setCreationErrorMessages($creationErrorMessages);
    }
    /**
     * Get CreationActionSuccess value
     * @return bool
     */
    public function getCreationActionSuccess()
    {
        return $this->CreationActionSuccess;
    }
    /**
     * Set CreationActionSuccess value
     * @param bool $creationActionSuccess
     * @return \StructType\SendGoodsInAdviceConfirmationResponse
     */
    public function setCreationActionSuccess($creationActionSuccess = null)
    {
        // validation for constraint: boolean
        if (!is_null($creationActionSuccess) && !is_bool($creationActionSuccess)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($creationActionSuccess, true), gettype($creationActionSuccess)), __LINE__);
        }
        $this->CreationActionSuccess = $creationActionSuccess;
        return $this;
    }
    /**
     * Get SendGoodsInAdviceConfirmationResult value
     * @return \StructType\SendGoodsInAdviceConfirmationResponse|null
     */
    public function getSendGoodsInAdviceConfirmationResult()
    {
        return $this->SendGoodsInAdviceConfirmationResult;
    }
    /**
     * Set SendGoodsInAdviceConfirmationResult value
     * @param \StructType\SendGoodsInAdviceConfirmationResponse $sendGoodsInAdviceConfirmationResult
     * @return \StructType\SendGoodsInAdviceConfirmationResponse
     */
    public function setSendGoodsInAdviceConfirmationResult(\StructType\SendGoodsInAdviceConfirmationResponse $sendGoodsInAdviceConfirmationResult = null)
    {
        $this->SendGoodsInAdviceConfirmationResult = $sendGoodsInAdviceConfirmationResult;
        return $this;
    }
    /**
     * Get GoodsInAdvices value
     * @return \ArrayType\ArrayOfGoodsInAdvice|null
     */
    public function getGoodsInAdvices()
    {
        return $this->GoodsInAdvices;
    }
    /**
     * Set GoodsInAdvices value
     * @param \ArrayType\ArrayOfGoodsInAdvice $goodsInAdvices
     * @return \StructType\SendGoodsInAdviceConfirmationResponse
     */
    public function setGoodsInAdvices(\ArrayType\ArrayOfGoodsInAdvice $goodsInAdvices = null)
    {
        $this->GoodsInAdvices = $goodsInAdvices;
        return $this;
    }
    /**
     * Get CreationErrorMessages value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getCreationErrorMessages()
    {
        return $this->CreationErrorMessages;
    }
    /**
     * Set CreationErrorMessages value
     * @param \ArrayType\ArrayOfString $creationErrorMessages
     * @return \StructType\SendGoodsInAdviceConfirmationResponse
     */
    public function setCreationErrorMessages(\ArrayType\ArrayOfString $creationErrorMessages = null)
    {
        $this->CreationErrorMessages = $creationErrorMessages;
        return $this;
    }
}
