<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendStockCorrectionResponse StructType
 * @subpackage Structs
 */
class SendStockCorrectionResponse extends BaseResponse
{
    /**
     * The CreationActionSuccess
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $CreationActionSuccess;
    /**
     * The SendStockCorrectionResult
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SendStockCorrectionResponse
     */
    public $SendStockCorrectionResult;
    /**
     * The CreationErrorMessages
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $CreationErrorMessages;
    /**
     * Constructor method for SendStockCorrectionResponse
     * @uses SendStockCorrectionResponse::setCreationActionSuccess()
     * @uses SendStockCorrectionResponse::setSendStockCorrectionResult()
     * @uses SendStockCorrectionResponse::setCreationErrorMessages()
     * @param bool $creationActionSuccess
     * @param \StructType\SendStockCorrectionResponse $sendStockCorrectionResult
     * @param \ArrayType\ArrayOfString $creationErrorMessages
     */
    public function __construct($creationActionSuccess = null, \StructType\SendStockCorrectionResponse $sendStockCorrectionResult = null, \ArrayType\ArrayOfString $creationErrorMessages = null)
    {
        $this
            ->setCreationActionSuccess($creationActionSuccess)
            ->setSendStockCorrectionResult($sendStockCorrectionResult)
            ->setCreationErrorMessages($creationErrorMessages);
    }
    /**
     * Get CreationActionSuccess value
     * @return bool
     */
    public function getCreationActionSuccess()
    {
        return $this->CreationActionSuccess;
    }
    /**
     * Set CreationActionSuccess value
     * @param bool $creationActionSuccess
     * @return \StructType\SendStockCorrectionResponse
     */
    public function setCreationActionSuccess($creationActionSuccess = null)
    {
        // validation for constraint: boolean
        if (!is_null($creationActionSuccess) && !is_bool($creationActionSuccess)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($creationActionSuccess, true), gettype($creationActionSuccess)), __LINE__);
        }
        $this->CreationActionSuccess = $creationActionSuccess;
        return $this;
    }
    /**
     * Get SendStockCorrectionResult value
     * @return \StructType\SendStockCorrectionResponse|null
     */
    public function getSendStockCorrectionResult()
    {
        return $this->SendStockCorrectionResult;
    }
    /**
     * Set SendStockCorrectionResult value
     * @param \StructType\SendStockCorrectionResponse $sendStockCorrectionResult
     * @return \StructType\SendStockCorrectionResponse
     */
    public function setSendStockCorrectionResult(\StructType\SendStockCorrectionResponse $sendStockCorrectionResult = null)
    {
        $this->SendStockCorrectionResult = $sendStockCorrectionResult;
        return $this;
    }
    /**
     * Get CreationErrorMessages value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getCreationErrorMessages()
    {
        return $this->CreationErrorMessages;
    }
    /**
     * Set CreationErrorMessages value
     * @param \ArrayType\ArrayOfString $creationErrorMessages
     * @return \StructType\SendStockCorrectionResponse
     */
    public function setCreationErrorMessages(\ArrayType\ArrayOfString $creationErrorMessages = null)
    {
        $this->CreationErrorMessages = $creationErrorMessages;
        return $this;
    }
}
